<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../">
  <title data-ice="title">scripts/development.js | text-io-simulator</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="Designed for simulating HP CodeWars input files and testing output, also has a version that can handle live input without modifing code."><meta property="twitter:card" content="summary"><meta property="twitter:title" content="text-io-simulator"><meta property="twitter:description" content="Designed for simulating HP CodeWars input files and testing output, also has a version that can handle live input without modifing code."></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/mr.code-joshua-cline/text-io-simulator.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  </ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">scripts/development.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">/**
 * This is the DEV textIOWrapper.
 * It will handle the actual data IO.
 * It is still in progress
 * @class
 * @in-progress
 */
class textIOWrapper{
  /**
   * Creates the object.
   * @param {URL} input - the input for the problem.
   * @param {URL} output - the output for the problem.
   * @param {object} options - any options in use.
   */
  constructor(input, output, options){
    /**
     * Array of lines of input.
     * @private
     * @type {String[]}
     */
    this.__inputLines = [];
    /**
     * How many lines have been read.
     * @public
     * @type {number}
     * @readonly
     */
    this.linesRead = 0;
    /**
     * Array of lines of output.
     * @private
     * @type {String[]}
     */
    this.__outputLines = [];
    /**
     * How many lines have been sent.
     * @public
     * @type {number}
     * @readonly
     */
    this.linesSent = 0;
    /**
     * Options for the wrapper
     * @public
     * @type {Object}
     * @prop {number} marginOfError The acceptable margin of error. (Will still display warnings)
     * @prop {boolean} isDevelopment If the current wrapper is development or live.
     */
    this.options = options || {};
    this.options.marginOfError || 0;
    this.options.isDevelopment = true;

    console.warn(&quot;YOU ARE RUNNING IN DEVELOPMENT, DO NOT SEND THIS CODE!&quot;);
  }
  /**
   * Gets a line of input.
   * @public
   * @return {String} The line of input.
   */
  getLine(){
    if(this.linesRead &gt;= this.__inputLines.length){
      this.debugLine(&quot;Program will never close, you asked for too many lines.&quot;, 4);
    }
    return this.__inputLines[this.linesRead++];
  }
  /**
   * Prints a debug line in dev, won&apos;t print anything in live.
   * In LIVE only level 4 will work.
   *
   * Avalible levels:
   * 0. Log
   * 1. Info
   * 2. Warn
   * 3. error
   * 4. throw
   * @public
   * @param {*} message - The message to output.
   * @param {number} [level=0] - The level of message.
   *
   */
  debugLine(message, level=0){
    switch (level) {
      case 0:
        console.log(message);
        break;
      case 1:
        console.info(message);
        break;
      case 2:
        console.warn(message);
        break;
      case 3:
        console.error(message);
        break;
      case 4:
        throw (message);
    }
  }
  /**
   * Prints a line of output.
   * @public
   * @param {String} outputString - A line of output.
   */
  sendLine(outputString){
    if(this.linesSent &gt;= this.__outputLines.length){
      throw &quot;Program returned too many lines.&quot;
    }
    __testLine(outputString, this.__outputLines[this.linesSent++]);
  }
  /**
   * Compares two lines of input.
   * @private
   * @param {String} generatedString - The string that was generated
   * @param {String} testString - The string to test aganst.
   *
   */
  __testLine(generatedString, testString){

  }
}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
